unit IxDemo;
interface
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, LwIXCmp, LwIX;
type
  TForm1 = class(TForm)
    IXEngine1: TIXEngine;
    btnReraiseIX: TButton;
    btnRaiseIX: TButton;
    btnRecastE: TButton;
    procedure btnReraiseIXClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function IXEngine1ShowMsger(IX	: EIncrementalException;
				   msgr : TEMessager): Boolean;
    procedure btnRaiseIXClick(Sender: TObject);
    procedure btnRecastEClick(Sender: TObject);
    function IXEngine1Recast(E: Exception; var IX: EIncrementalException): Boolean;
  private
    { Private declarations }
  public
    property IXEngine : TIXEngine read IXEngine1;
  end;

var
  Form1: TForm1;

implementation
uses LwMsgrTC;

{$R *.DFM}
const
{$I LwIXE.INC }   {- to have help context constants }


  procedure RaiseOne;
  var IX : EIncrementalException;
  begin
    Form1.IXEngine.RaiseIX (mck_Custom, [4, 1001,
		  'New Incremental eXception was raised',
		  'in RaiseOne of unit IxDemo.'],
		  mi_TIXEng_RaiseIX, IX);
  end;

  procedure TForm1.btnRaiseIXClick(Sender: TObject);
  begin
    RaiseOne;
  end;

  procedure TForm1.btnReraiseIXClick(Sender: TObject);
  begin
    try
      RaiseOne;
    except
      on E : Exception do
      if IXEngine.RecastToIX (E, mck_Custom,
		  [4, 1301,
		   'An exception was intercepted in btnReraiseIXClick of TForm1.',
		   'It is recast to an Incremental eXception.'],
		   mi_TIXEng_RecastToIX) then
	raise;
    end;
  end;

  procedure TForm1.FormCreate(Sender: TObject);
  var IX : EIncrementalException;
  begin
    {- indicate to IXEngine your TEMessager subclass (if any) }
    IXEngine.MessagerClass := TEMessagerTC;

    {- decomment to provoke an exception during form creation
    IXEngine.RaiseIX (mck_Custom,
                      [5, 1401, 'Raised in TForm1.FormCreate'],
                      mi_TIXEng_RaiseIX, IX);
    }
  end;

  function TForm1.IXEngine1Recast(    E  : Exception;
				  var IX : EIncrementalException): Boolean;
  begin
    if E is EOutOfMemory then
      {- no room for our "fancy" recasting; leave E as is and provoke its reraising }
      Result := true else
    if (E is EIntError) or
       (E is EMathError) or
       (E is EInvalidPointer) or
       (E is EInvalidCast) or
       (E is EConvertError) or
       (E is EProcessorException) then
    begin
      Result := false;
      IXEngine.RaiseIX (mck_Custom, [0, 1, E.Message], 0, IX);
    end;
  end;

  function TForm1.IXEngine1ShowMsger(IX   : EIncrementalException;
				     msgr : TEMessager): Boolean;
  begin
    Result := true;
    IXEngine1.MemoBoard.Lines.Insert (IXEngine1.MemoBoard.Lines.Count,
				      '====== '+
				      IntToStr (IX.ErrCount-IX.IndexOfMsger(msgr)) +'/'+
				      IntToStr (IX.ErrCount) +' : '+
				      msgr.MinimalErrorMsg);
  end;

  function ArithmeticOne : real;
  var x : real;
  begin
    x := 2;
    try
      Result := 5 / (x-x);
    except
      on E : Exception do
      if Form1.IXEngine.RecastToIX (E, mck_Custom,
		  [4, 1002,
		   'An exception occurred in ArithmeticOne.',
		   'It was recast to an Incremental eXception.'],
		   mi_TIXEng_RecastToIX) then
	raise;
    end;
  end;

  procedure TForm1.btnRecastEClick(Sender: TObject);
  begin
    try
      ArithmeticOne;
    except
      on E : Exception do
      if IXEngine.RecastToIX (E, mck_Custom,
		  [4, 1301,
		   'An exception was intercepted in btnRecastIXClick of TForm1.'],
		   mi_TIXEng_RecastToIX) then
	raise;
    end;
  end;

end.
