program Ix_Demo;
uses
  SysUtils,   {- to have Exception }
  LwIXFrm,    {- to have DefaultIXEngineForm }
  LwIX,       {- to have mck_... constants }
  Forms,
  IxDemo in 'IXDEMO.PAS' {Form1};

{$R *.RES}
const
{$I LwIXE.INC }   {- to have help context constants }

begin
  {- Below we have example when DefaultIXEngineForm could be useful if
     Delphi's default exception handling in TForm.Create were not
     non-Abort-exception-eater as it is now }
  try
    Application.HelpFile := 'LwIXE.hlp';
      {- will be the target of IXEngineForm's Help button }
    Application.CreateForm(TForm1, Form1);
  except
    on E : Exception do
      if DefaultIXEngineForm.RecastToIX (E, mck_Custom,
         [4, 1011, 'Project initialization failure.'], ti_Epilog) then
        raise;
      {- Even if we raise an exception in the above CreateForm,
	 we don't reach this block because TForm.Create contains
	   try
	     if Assigned(FOnCreate) then FOnCreate(Self);
	   except
	     Application.HandleException(Self);
	   end;
	 and Delphi's default HandleException is just ShowException.
	 Hence, it is Delphi's choice which we can modify since we
	 substitute (in TIXEngineForm.FormCreate) our
	 TIXEngineForm.ShowException for Application.ShowException.
       }
  end;
  Application.Run;
end.
