unit LwAOCons;		{- Array Of Const routines }
interface
type PArrayOfConst = ^TArrayOfConst;
     TArrayOfConst = array [0..1000] of TVarRec;

  function  GetSubArrayOfConst (const params : array of const;
				      start  : word;
				      arrL   : word) : PArrayOfConst;
    {- Don't forget to deallocate the Result with FreeSubArrayOfConst }
  function  CatArrayOfConst (const AOC1  : array of const;
				   arrL1 : word;
			     const AOC2  : array of const;
				   arrL2 : word) : PArrayOfConst;
    {- Don't forget to deallocate the Result with FreeSubArrayOfConst }
  procedure FreeSubArrayOfConst (var AOCp : PArrayOfConst;
				     arrL : word);
  function FormatArgs (ss : string) : integer;
    {- returns number of %-formating arguments in ss }

implementation {=============================================================}

  function GetSubArrayOfConst (const params : array of const;
				     start  : word;
				     arrL   : word) : PArrayOfConst;
  var size : word;
  begin
    size := arrL * SizeOf(TVarRec);
    GetMem (Result, size);
    Move (params[start], Result^, size);
  end;

  function  CatArrayOfConst (const AOC1  : array of const;
				   arrL1 : word;
			     const AOC2  : array of const;
				   arrL2 : word) : PArrayOfConst;
  begin
    GetMem (Result, (arrL1 + arrL2) * SizeOf(TVarRec));
    Move (AOC1, Result^, arrL1 * SizeOf(TVarRec));
    Move (AOC2, Result^[arrL1], arrL2 * SizeOf(TVarRec));
  end;

  procedure FreeSubArrayOfConst (var AOCp : PArrayOfConst;
				     arrL : word);
  begin
    FreeMem (AOCp, arrL * SizeOf(TVarRec));
    AOCp := nil;
  end;

  function FormatArgs (ss : string) : integer;
  var ii : integer;
  begin
    Result := 0;
    ii:=1;
    while ii < length(ss) do
    begin
      if ss[ii]='%' then
      begin
	inc(ii);
	if ss[ii]<>'%' then
	  inc(Result);
      end;
      inc(ii);
    end;
  end;

end.
