unit LwIX;		   {- LW incremental eXception }
interface
uses SysUtils,
     Classes;
const {==================== Messager Creation Kinds =========================}
  mck_Custom	   = 0;
  mck_CustomFmt    = mck_Custom       + 1;
  mck_Res	   = mck_CustomFmt    + 1;
  mck_ResFmt	   = mck_Res	      + 1;
  mck_User	   = mck_ResFmt       + 1;  {- first to define by User }

type
  {============================ TEMessager ==================================}

  TEMessagerClass = class of TEMessager;
  PEMessager = ^TEMessager;		 {- for pointer typecast in debugging }
  TEMessager = class (TStringList)
  protected
    function MinErrMsg : string;				       virtual;
      {- minimal message for SysUtils.ShowException }
  public
    constructor Create (      mcKind : integer;
			const params : array of const;
			      parCnt : integer);		       virtual;
    {
      mck_Custom    :  params := [<msg line>,
				  <msg line>, ... ]
      mck_CustomFmt :  params := [<fmt line>, arg, ..., arg,
				  <fmt line>, arg, ..., arg,  ...]
      mck_Res	    :  params := [<res idx of msg line>,
				  <res idx of msg line>, ... ]
      mck_ResFmt    :  params := [<res idx of fmt line>, arg, ... arg,
				  <res idx of fmt line>, arg, ... arg,	...]
    }
    property MinimalErrorMsg : string read MinErrMsg;
    procedure AppendToShow (const memoStrs : TStrings); 	       virtual;
    {
      Shouldn't change the elements currently in memoStrs but is supposed to
      insert supplementary strings to be shown to the user
    }
  end;

  {====================== EIncrementalException =============================}

  EIncrementalException = class (Exception)
  private
    FErrMsgers : TStringList;
      {- as list of TEMessager; we don't use TList since we need IndexOfObject }
    function GetErrMsger (idx : integer): TEMessager;
    function GetErrCount : integer;
    function GetFirstErrMsger : TEMessager;
    function GetLastErrMsger : TEMessager;
  public
    constructor Create (      msgrClass  : TEMessagerClass;
			      mcKind	 : integer;
			const msgrParams : array of const;
			      hc	 : THelpContext);
    destructor Destroy; 					      override;
    procedure Add (	 msgrClass  : TEMessagerClass;
			 mcKind     : integer;
		   const msgrParams : array of const;
			 hc	    : THelpContext);
    function IndexOfMsger (msgr : TEMessager) : integer;
    property ErrCount : integer read GetErrCount;
    property ErrMsgers [idx : integer] : TEMessager read GetErrMsger;
    property FirstErrMsger : TEMessager read GetFirstErrMsger;
    property LastErrMsger : TEMessager read GetLastErrMsger;
  end;

implementation {=============================================================}
uses LwAOCons;
const
  str_BadEMassagerParams = 'Invalid params in TEMessager.Create';

  {$I LwIX.IN1	      }  { TEMessager		}
  {$I LwIX.IN2	      }  { EIncrementalException}

end.
