unit LwIXCmp;	 {- Incremental eXceptions Component }
interface
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, Dialogs,
  LwIX, LwIXFrm;

type
  TIXEngine = class(TComponent)
  private
    FIXEngineForm : TIXEngineForm;
  protected
    function  GetMessagerClass : TEMessagerClass;
    procedure SetMessagerClass (EMC : TEMessagerClass);
    function  GetMemoBoard : TMemo;
    function  GetMemoCaption : string;
    procedure SetMemoCaption (ss : string);
    function  GetMemoHint : string;
    procedure SetMemoHint (ss : string);
    function  GetOnRecast : TOnRecastEvent;
    procedure SetOnRecast (event : TOnRecastEvent);
    function  GetOnShowMsger : TOnShowMsgerEvent;
    procedure SetOnShowMsger (event : TOnShowMsgerEvent);
  public
    constructor Create (AOwner : TComponent);			      override;
    destructor Destroy; 					      override;
    procedure RaiseIX (      mcKind	: integer;
		       const msgrParams : array of const;
			     hc 	: THelpContext;
		       var   IX 	: EIncrementalException);
    function  RecastToIX (	E	   : Exception;
				mcKind	   : integer;
			  const msgrParams : array of const;
				hc	   : THelpContext) : boolean;
    property MessagerClass : TEMessagerClass read GetMessagerClass write SetMessagerClass;
    property MemoBoard : TMemo read GetMemoBoard;
  published
    property MemoCaption : string read GetMemoCaption write SetMemoCaption;
    property MemoHint : string read GetMemoHint write SetMemoHint;
    property OnRecast : TOnRecastEvent read GetOnRecast write SetOnRecast;
    property OnShowMsger : TOnShowMsgerEvent read GetOnShowMsger write SetOnShowMsger;
  end;

  procedure Register;

implementation {==============================================================}

  constructor TIXEngine.Create (AOwner : TComponent);
  begin
    inherited Create(AOwner);

    if Assigned (DefaultIXEngineForm) then
      FIXEngineForm := DefaultIXEngineForm else
    FIXEngineForm.Create(AOwner);
  end;

  destructor TIXEngine.Destroy;
  begin
    if Assigned (DefaultIXEngineForm) then
      FIXEngineForm := nil;

    inherited Destroy;
  end;

  function  TIXEngine.GetMessagerClass : TEMessagerClass;
  begin Result := FIXEngineForm.MessagerClass end;

  procedure TIXEngine.SetMessagerClass (EMC : TEMessagerClass);
  begin FIXEngineForm.MessagerClass := EMC end;

  function  TIXEngine.GetMemoBoard : TMemo;
  begin Result := FIXEngineForm.MemoBoard end;

  function  TIXEngine.GetMemoCaption : string;
  begin Result := FIXEngineForm.Caption end;

  procedure TIXEngine.SetMemoCaption (ss : string);
  begin FIXEngineForm.Caption := ss end;

  function  TIXEngine.GetMemoHint : string;
  begin Result := FIXEngineForm.MemoBoard.Hint end;

  procedure TIXEngine.SetMemoHint (ss : string);
  begin FIXEngineForm.MemoBoard.Hint := ss end;

  function  TIXEngine.GetOnRecast : TOnRecastEvent;
  begin Result := FIXEngineForm.OnRecast end;

  procedure TIXEngine.SetOnRecast (event : TOnRecastEvent);
  begin FIXEngineForm.OnRecast := event end;

  function  TIXEngine.GetOnShowMsger : TOnShowMsgerEvent;
  begin Result := FIXEngineForm.OnShowMsger end;

  procedure TIXEngine.SetOnShowMsger (event : TOnShowMsgerEvent);
  begin FIXEngineForm.OnShowMsger := event end;

  procedure TIXEngine.RaiseIX (      mcKind	: integer;
			       const msgrParams : array of const;
				     hc 	: THelpContext;
			       var   IX 	: EIncrementalException);
  begin FIXEngineForm.RaiseIX (mcKind, msgrParams, hc, IX) end;

  function  TIXEngine.RecastToIX (	E	   : Exception;
					mcKind	   : integer;
				  const msgrParams : array of const;
					hc	   : THelpContext) : boolean;
  begin Result := FIXEngineForm.RecastToIX (E, mcKind, msgrParams, hc) end;

  procedure Register;
  begin
    RegisterComponents('Standard', [TIXEngine]);
  end;

end.
